diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/icmpv6-header.cc ns-3.34/src/internet/model/icmpv6-header.cc
--- ns-3.33/src/internet/model/icmpv6-header.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/icmpv6-header.cc	2021-07-14 10:31:06.000000000 -0700
@@ -503,7 +503,6 @@
   NS_LOG_FUNCTION (this);
   SetType (ICMPV6_ND_ROUTER_ADVERTISEMENT);
   SetCode (0);
-  SetFlags (0);
   SetFlagM (0);
   SetFlagO (0);
   SetFlagH (0);
@@ -605,13 +604,12 @@
 uint8_t Icmpv6RA::GetFlags () const
 {
   NS_LOG_FUNCTION (this);
-  return m_flags;
+  return 0;
 }
 
 void Icmpv6RA::SetFlags (uint8_t f)
 {
   NS_LOG_FUNCTION (this << static_cast<uint32_t> (f));
-  m_flags = f;
 }
 
 void Icmpv6RA::Print (std::ostream& os) const
@@ -674,22 +672,22 @@
   SetCode (i.ReadU8 ());
   m_checksum = i.ReadU16 ();
   SetCurHopLimit (i.ReadU8 ());
-  m_flags = i.ReadU8 ();
+  uint8_t flags = i.ReadU8 ();
   m_flagM = false;
   m_flagO = false;
   m_flagH = false;
 
-  if (m_flags & (1 << 7))
+  if (flags & (1 << 7))
     {
       m_flagM = true;
     }
 
-  if (m_flags & (1 << 6))
+  if (flags & (1 << 6))
     {
       m_flagO = true;
     }
 
-  if (m_flags & (1 << 5))
+  if (flags & (1 << 5))
     {
       m_flagH = true;
     }
@@ -993,7 +991,8 @@
 {
   NS_LOG_FUNCTION (this << &os);
   os << "( type = " << (GetType () == 128 ? "128 (Request)" : "129 (Reply)") << 
-  " code = " << (uint32_t)GetCode () <<
+  " Id = " << (uint32_t)GetId () <<
+  " SeqNo = " << (uint32_t)GetSeq () <<
   " checksum = "  << (uint32_t)GetChecksum () << ")";
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/icmpv6-header.h ns-3.34/src/internet/model/icmpv6-header.h
--- ns-3.33/src/internet/model/icmpv6-header.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/icmpv6-header.h	2021-07-14 10:31:06.000000000 -0700
@@ -685,12 +685,14 @@
    * \brief Getflags.
    * \return the flags value
    */
+  NS_DEPRECATED_3_34
   uint8_t GetFlags () const;
 
   /**
    * \brief Setflags.
    * \param f the flags value
    */
+  NS_DEPRECATED_3_34
   void SetFlags (uint8_t f);
 
   /**
@@ -729,11 +731,6 @@
   bool m_flagH;
 
   /**
-   * \brief The flags field value.
-   */
-  uint8_t m_flags;
-
-  /**
    * \brief The lifetime value.
    */
   uint16_t m_LifeTime;
@@ -1501,6 +1498,17 @@
   virtual TypeId GetInstanceTypeId () const;
 
   /**
+   * \brief Icmpv6 Option Prefix Information flag field values
+   */
+  typedef enum
+  {
+    NONE         = 0,   //!< No flags
+    ROUTERADDR   = 32,  //!< Router Address
+    AUTADDRCONF  = 64,  //!< Autonomous Address Configuration
+    ONLINK       = 128  //!< On-link
+  } Flags_t;
+
+  /**
    * \brief Get the prefix length.
    * \return prefix length
    */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/icmpv6-l4-protocol.cc ns-3.34/src/internet/model/icmpv6-l4-protocol.cc
--- ns-3.33/src/internet/model/icmpv6-l4-protocol.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/icmpv6-l4-protocol.cc	2021-07-14 10:31:06.000000000 -0700
@@ -522,45 +522,74 @@
       return;
     }
 
-  Icmpv6OptionLinkLayerAddress lla (1);
-  Address hardwareAddress;
   NdiscCache::Entry* entry = 0;
   Ptr<NdiscCache> cache = FindCache (interface->GetDevice ());
   uint8_t flags = 0;
 
-  /* XXX search all options following the NS header */
+  /* search all options following the NS header */
+  Icmpv6OptionLinkLayerAddress sllaoHdr (true);
 
-  if (src != Ipv6Address::GetAny ())
+  bool next = true;
+  bool hasSllao = false;
+
+  while (next == true)
     {
       uint8_t type;
-      packet->CopyData (&type, sizeof(type));
+      packet->CopyData (&type, sizeof (type));
 
-      if (type != Icmpv6Header::ICMPV6_OPT_LINK_LAYER_SOURCE)
+      switch (type)
         {
-          return;
+          case Icmpv6Header::ICMPV6_OPT_LINK_LAYER_SOURCE:
+            if (!hasSllao)
+              {
+                packet->RemoveHeader (sllaoHdr);
+                hasSllao = true;
+              }
+            break;
+          default:
+            /* unknow option, quit */
+            next = false;
+        }
+      if (packet->GetSize () == 0)
+        {
+          next = false;
         }
+    }
 
-      /* Get LLA */
-      packet->RemoveHeader (lla);
+  Address replyMacAddress;
 
+  if (src != Ipv6Address::GetAny ())
+    {
       entry = cache->Lookup (src);
       if (!entry)
         {
+          if (!hasSllao)
+            {
+              NS_LOG_LOGIC ("Icmpv6L4Protocol::HandleNS: NS without SLLAO and we do not have a NCE, discarding.");
+              return;
+            }
           entry = cache->Add (src);
           entry->SetRouter (false);
-          entry->MarkStale (lla.GetAddress ());
+          entry->MarkStale (sllaoHdr.GetAddress ());
+          replyMacAddress = sllaoHdr.GetAddress ();
         }
-      else if (entry->GetMacAddress () != lla.GetAddress ())
+      else if (hasSllao && (entry->GetMacAddress () != sllaoHdr.GetAddress ()))
         {
-          entry->MarkStale (lla.GetAddress ());
+          entry->MarkStale (sllaoHdr.GetAddress ());
+          replyMacAddress = sllaoHdr.GetAddress ();
+        }
+      else
+        {
+          replyMacAddress = entry->GetMacAddress ();
         }
 
       flags = 3; /* S + O flags */
     }
   else
     {
-      /* it means someone do a DAD */
+      /* it's a DAD */
       flags = 1; /* O flag */
+      replyMacAddress = interface->GetDevice ()->GetMulticast (dst);
     }
 
   /* send a NA to src */
@@ -571,14 +600,16 @@
       flags += 4; /* R flag */
     }
 
-  hardwareAddress = interface->GetDevice ()->GetAddress ();
+  Address hardwareAddress = interface->GetDevice ()->GetAddress ();
   NdiscCache::Ipv6PayloadHeaderPair p = ForgeNA (target.IsLinkLocal () ? interface->GetLinkLocalAddress ().GetAddress () : ifaddr.GetAddress (),
                                                  src.IsAny () ? dst : src, // DAD replies must go to the multicast group it was sent to.
                                                  &hardwareAddress,
                                                  flags );
-  interface->Send (p.first, p.second, src.IsAny () ? Ipv6Address::GetAllNodesMulticast () : src);
 
-  /* not a NS for us discard it */
+  // We must bypass the IPv6 layer, as a NA must be sent regardless of the NCE status (and not change it beyond what we did already).
+  Ptr<Packet> pkt = p.first;
+  pkt->AddHeader (p.second);
+  interface->GetDevice ()->Send (pkt, replyMacAddress, Ipv6L3Protocol::PROT_NUMBER);
 }
 
 NdiscCache::Ipv6PayloadHeaderPair Icmpv6L4Protocol::ForgeRS (Ipv6Address src, Ipv6Address dst, Address hardwareAddress)
@@ -587,10 +618,16 @@
   Ptr<Packet> p = Create<Packet> ();
   Ipv6Header ipHeader;
   Icmpv6RS rs;
-  Icmpv6OptionLinkLayerAddress llOption (1, hardwareAddress);  /* we give our mac address in response */
 
-  NS_LOG_LOGIC ("Send RS ( from " << src << " to " << dst << ")");
-  p->AddHeader (llOption);
+  NS_LOG_LOGIC ("Forge RS (from " << src << " to " << dst << ")");
+  // RFC 4861:
+  // The link-layer address of the sender MUST NOT be included if the Source Address is the unspecified address.
+  // Otherwise, it SHOULD be included on link layers that have addresses.
+  if (!src.IsAny ())
+    {
+      Icmpv6OptionLinkLayerAddress llOption (1, hardwareAddress);  /* we give our mac address in response */
+      p->AddHeader (llOption);
+    }
 
   rs.CalculatePseudoHeaderChecksum (src, dst, p->GetSize () + rs.GetSerializedSize (), PROT_NUMBER);
   p->AddHeader (rs);
@@ -1036,15 +1073,17 @@
   NS_LOG_FUNCTION (this << src << dst << hardwareAddress);
   Ptr<Packet> p = Create<Packet> ();
   Icmpv6RS rs;
-  Icmpv6OptionLinkLayerAddress llOption (1, hardwareAddress);  /* we give our mac address in response */
 
-  /* if the source is unspec, multicast the NA to all-nodes multicast */
-  if (src != Ipv6Address::GetAny ())
+  // RFC 4861:
+  // The link-layer address of the sender MUST NOT be included if the Source Address is the unspecified address.
+  // Otherwise, it SHOULD be included on link layers that have addresses.
+  if (!src.IsAny ())
     {
+      Icmpv6OptionLinkLayerAddress llOption (1, hardwareAddress);
       p->AddHeader (llOption);
     }
 
-  NS_LOG_LOGIC ("Send RS ( from " << src << " to " << dst << ")");
+  NS_LOG_LOGIC ("Send RS (from " << src << " to " << dst << ")");
 
   rs.CalculatePseudoHeaderChecksum (src, dst, p->GetSize () + rs.GetSerializedSize (), PROT_NUMBER);
   p->AddHeader (rs);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/icmpv6-l4-protocol.h ns-3.34/src/internet/model/icmpv6-l4-protocol.h
--- ns-3.33/src/internet/model/icmpv6-l4-protocol.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/icmpv6-l4-protocol.h	2021-07-14 10:31:06.000000000 -0700
@@ -316,7 +316,6 @@
 
   /**
    * \brief Function called when DAD timeout.
-   * \param icmpv6 Icmpv6L4Protocol instance
    * \param interface the interface
    * \param addr the IPv6 address
    */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv4-global-routing.cc ns-3.34/src/internet/model/ipv4-global-routing.cc
--- ns-3.33/src/internet/model/ipv4-global-routing.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv4-global-routing.cc	2021-07-14 10:31:06.000000000 -0700
@@ -402,6 +402,11 @@
 {
   NS_LOG_FUNCTION (this << stream);
   std::ostream* os = stream->GetStream ();
+  // Copy the current ostream state
+  std::ios oldState (nullptr);
+  oldState.copyfmt (*os);
+
+  *os << std::resetiosflags (std::ios::adjustfield) << std::setiosflags (std::ios::left);
 
   *os << "Node: " << m_ipv4->GetObject<Node> ()->GetId ()
       << ", Time: " << Now().As (unit)
@@ -416,11 +421,11 @@
           std::ostringstream dest, gw, mask, flags;
           Ipv4RoutingTableEntry route = GetRoute (j);
           dest << route.GetDest ();
-          *os << std::setiosflags (std::ios::left) << std::setw (16) << dest.str ();
+          *os << std::setw (16) << dest.str ();
           gw << route.GetGateway ();
-          *os << std::setiosflags (std::ios::left) << std::setw (16) << gw.str ();
+          *os << std::setw (16) << gw.str ();
           mask << route.GetDestNetworkMask ();
-          *os << std::setiosflags (std::ios::left) << std::setw (16) << mask.str ();
+          *os << std::setw (16) << mask.str ();
           flags << "U";
           if (route.IsHost ())
             {
@@ -430,7 +435,7 @@
             {
               flags << "G";
             }
-          *os << std::setiosflags (std::ios::left) << std::setw (6) << flags.str ();
+          *os << std::setw (6) << flags.str ();
           // Metric not implemented
           *os << "-" << "      ";
           // Ref ct not implemented
@@ -449,6 +454,8 @@
         }
     }
   *os << std::endl;
+  // Restore the previous ostream state
+  (*os).copyfmt (oldState);
 }
 
 Ptr<Ipv4Route>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv4-l3-protocol.h ns-3.34/src/internet/model/ipv4-l3-protocol.h
--- ns-3.33/src/internet/model/ipv4-l3-protocol.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv4-l3-protocol.h	2021-07-14 10:31:06.000000000 -0700
@@ -622,8 +622,7 @@
    */
   bool UpdateDuplicate (Ptr<const Packet> p, const Ipv4Header &header);
   /**
-   * Remove duplicate packet entry
-   * \param [in] iter Iterator into duplicate map to remove
+   * Remove expired duplicates packet entry
    */
   void RemoveDuplicates (void);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv4-static-routing.cc ns-3.34/src/internet/model/ipv4-static-routing.cc
--- ns-3.33/src/internet/model/ipv4-static-routing.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv4-static-routing.cc	2021-07-14 10:31:06.000000000 -0700
@@ -67,12 +67,17 @@
                                       uint32_t metric)
 {
   NS_LOG_FUNCTION (this << network << " " << networkMask << " " << nextHop << " " << interface << " " << metric);
-  Ipv4RoutingTableEntry *route = new Ipv4RoutingTableEntry ();
-  *route = Ipv4RoutingTableEntry::CreateNetworkRouteTo (network,
-                                                        networkMask,
-                                                        nextHop,
-                                                        interface);
-  m_networkRoutes.push_back (make_pair (route,metric));
+
+  Ipv4RoutingTableEntry route = Ipv4RoutingTableEntry::CreateNetworkRouteTo (network,
+                                                                             networkMask,
+                                                                             nextHop,
+                                                                             interface);
+
+  if (!LookupRoute (route, metric))
+    {
+      Ipv4RoutingTableEntry *routePtr = new Ipv4RoutingTableEntry (route);
+      m_networkRoutes.push_back (make_pair (routePtr, metric));
+    }
 }
 
 void 
@@ -82,11 +87,16 @@
                                       uint32_t metric)
 {
   NS_LOG_FUNCTION (this << network << " " << networkMask << " " << interface << " " << metric);
-  Ipv4RoutingTableEntry *route = new Ipv4RoutingTableEntry ();
-  *route = Ipv4RoutingTableEntry::CreateNetworkRouteTo (network,
-                                                        networkMask,
-                                                        interface);
-  m_networkRoutes.push_back (make_pair (route,metric));
+
+  Ipv4RoutingTableEntry route = Ipv4RoutingTableEntry::CreateNetworkRouteTo (network,
+                                                                             networkMask,
+                                                                             interface);
+  if (!LookupRoute (route, metric))
+    {
+      Ipv4RoutingTableEntry *routePtr = new Ipv4RoutingTableEntry (route);
+
+      m_networkRoutes.push_back (make_pair (routePtr, metric));
+    }
 }
 
 void 
@@ -219,6 +229,25 @@
     }
 }
 
+bool
+Ipv4StaticRouting::LookupRoute (const Ipv4RoutingTableEntry &route, uint32_t metric)
+{
+  for (NetworkRoutesI j = m_networkRoutes.begin (); j != m_networkRoutes.end (); j++)
+    {
+      Ipv4RoutingTableEntry* rtentry = j->first;
+
+      if (rtentry->GetDest () == route.GetDest () &&
+          rtentry->GetDestNetworkMask () == route.GetDestNetworkMask () &&
+          rtentry->GetGateway () == route.GetGateway () &&
+          rtentry->GetInterface () == route.GetInterface () &&
+          j->second == metric)
+        {
+          return true;
+        }
+    }
+  return false;
+}
+
 Ptr<Ipv4Route>
 Ipv4StaticRouting::LookupStatic (Ipv4Address dest, Ptr<NetDevice> oif)
 {
@@ -694,6 +723,11 @@
 {
   NS_LOG_FUNCTION (this << stream);
   std::ostream* os = stream->GetStream ();
+  // Copy the current ostream state
+  std::ios oldState (nullptr);
+  oldState.copyfmt (*os);
+
+  *os << std::resetiosflags (std::ios::adjustfield) << std::setiosflags (std::ios::left);
 
   *os << "Node: " << m_ipv4->GetObject<Node> ()->GetId ()
       << ", Time: " << Now().As (unit)
@@ -708,11 +742,11 @@
           std::ostringstream dest, gw, mask, flags;
           Ipv4RoutingTableEntry route = GetRoute (j);
           dest << route.GetDest ();
-          *os << std::setiosflags (std::ios::left) << std::setw (16) << dest.str ();
+          *os << std::setw (16) << dest.str ();
           gw << route.GetGateway ();
-          *os << std::setiosflags (std::ios::left) << std::setw (16) << gw.str ();
+          *os << std::setw (16) << gw.str ();
           mask << route.GetDestNetworkMask ();
-          *os << std::setiosflags (std::ios::left) << std::setw (16) << mask.str ();
+          *os << std::setw (16) << mask.str ();
           flags << "U";
           if (route.IsHost ())
             {
@@ -722,8 +756,8 @@
             {
               flags << "GS";
             }
-          *os << std::setiosflags (std::ios::left) << std::setw (6) << flags.str ();
-          *os << std::setiosflags (std::ios::left) << std::setw (7) << GetMetric (j);
+          *os << std::setw (6) << flags.str ();
+          *os << std::setw (7) << GetMetric (j);
           // Ref ct not implemented
           *os << "-" << "      ";
           // Use not implemented
@@ -740,6 +774,8 @@
         }
     }
   *os << std::endl;
+  // Restore the previous ostream state
+  (*os).copyfmt (oldState);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv4-static-routing.h ns-3.34/src/internet/model/ipv4-static-routing.h
--- ns-3.33/src/internet/model/ipv4-static-routing.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv4-static-routing.h	2021-07-14 10:31:06.000000000 -0700
@@ -377,6 +377,14 @@
   typedef std::list<Ipv4MulticastRoutingTableEntry *>::iterator MulticastRoutesI;
 
   /**
+   * \brief Checks if a route is already present in the forwarding table.
+   * \param route route
+   * \param metric metric of route
+   * \return true if the route/metric is already in the forwarding table
+   */
+  bool LookupRoute (const Ipv4RoutingTableEntry &route, uint32_t metric);
+
+  /**
    * \brief Lookup in the forwarding table for destination.
    * \param dest destination address
    * \param oif output interface if any (put 0 otherwise)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv6-extension-header.h ns-3.34/src/internet/model/ipv6-extension-header.h
--- ns-3.33/src/internet/model/ipv6-extension-header.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv6-extension-header.h	2021-07-14 10:31:06.000000000 -0700
@@ -89,7 +89,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
 
@@ -248,7 +247,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
 
@@ -305,7 +303,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
 
@@ -398,7 +395,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
 
@@ -490,7 +486,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
 
@@ -590,7 +585,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
 
@@ -658,7 +652,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
 
@@ -715,7 +708,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv6.h ns-3.34/src/internet/model/ipv6.h
--- ns-3.33/src/internet/model/ipv6.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv6.h	2021-07-14 10:31:06.000000000 -0700
@@ -186,9 +186,10 @@
    * \brief Add an address on the specified IPv6 interface.
    * \param interface Interface number of an IPv6 interface
    * \param address Ipv6InterfaceAddress address to associate with the underlying IPv6 interface
+   * \param addOnLinkRoute add on-link route to the network (default true)
    * \returns true if the operation succeeded
    */
-  virtual bool AddAddress (uint32_t interface, Ipv6InterfaceAddress address) = 0;
+  virtual bool AddAddress (uint32_t interface, Ipv6InterfaceAddress address, bool addOnLinkRoute = true) = 0;
 
   /**
    * \brief Get number of addresses on specified IPv6 interface.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv6-header.h ns-3.34/src/internet/model/ipv6-header.h
--- ns-3.33/src/internet/model/ipv6-header.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv6-header.h	2021-07-14 10:31:06.000000000 -0700
@@ -249,7 +249,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream& os) const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv6-interface-address.cc ns-3.34/src/internet/model/ipv6-interface-address.cc
--- ns-3.33/src/internet/model/ipv6-interface-address.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv6-interface-address.cc	2021-07-14 10:31:06.000000000 -0700
@@ -35,6 +35,7 @@
     m_prefix (Ipv6Prefix ()),
     m_state (TENTATIVE_OPTIMISTIC),
     m_scope (HOST),
+    m_onLink (true),
     m_nsDadUid (0)
 {
   NS_LOG_FUNCTION (this);
@@ -46,6 +47,7 @@
   m_prefix = Ipv6Prefix (64);
   SetAddress (address);
   SetState (TENTATIVE_OPTIMISTIC);
+  m_onLink = true;
   m_nsDadUid = 0;
 }
 
@@ -55,6 +57,17 @@
   m_prefix = prefix;
   SetAddress (address);
   SetState (TENTATIVE_OPTIMISTIC);
+  m_onLink = true;
+  m_nsDadUid = 0;
+}
+
+Ipv6InterfaceAddress::Ipv6InterfaceAddress (Ipv6Address address, Ipv6Prefix prefix, bool onLink)
+{
+  NS_LOG_FUNCTION (this << address << prefix << onLink);
+  m_prefix = prefix;
+  SetAddress (address);
+  SetState (TENTATIVE_OPTIMISTIC);
+  m_onLink = onLink;
   m_nsDadUid = 0;
 }
 
@@ -63,6 +76,7 @@
     m_prefix (o.m_prefix),
     m_state (o.m_state),
     m_scope (o.m_scope),
+    m_onLink (o.m_onLink),
     m_nsDadUid (o.m_nsDadUid)
 {
 }
@@ -193,6 +207,18 @@
   m_nsDadUid = nsDadUid;
 }
 
+bool Ipv6InterfaceAddress::GetOnLink () const
+{
+  NS_LOG_FUNCTION (this);
+  return m_onLink;
+}
+
+void Ipv6InterfaceAddress::SetOnLink (bool onLink)
+{
+  NS_LOG_FUNCTION (this << onLink);
+  m_onLink = onLink;
+}
+
 #if 0
 void Ipv6InterfaceAddress::StartDadTimer (Ptr<Ipv6Interface> interface)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv6-interface-address.h ns-3.34/src/internet/model/ipv6-interface-address.h
--- ns-3.33/src/internet/model/ipv6-interface-address.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv6-interface-address.h	2021-07-14 10:31:06.000000000 -0700
@@ -82,6 +82,14 @@
   Ipv6InterfaceAddress (Ipv6Address address, Ipv6Prefix prefix);
 
   /**
+   * \brief Constructor.
+   * \param address IPv6 address to set
+   * \param prefix IPv6 prefix
+   * \param onLink on-link property
+   */
+  Ipv6InterfaceAddress (Ipv6Address address, Ipv6Prefix prefix, bool onLink);
+
+  /**
    * \brief Copy constructor.
    * \param o object to copy
    */
@@ -153,6 +161,18 @@
    */
   uint32_t GetNsDadUid () const;
 
+  /**
+   * \brief Get the on-link property.
+   * \param onLink the on-link property
+   */
+  void SetOnLink (bool onLink);
+
+  /**
+   * \brief Get the on-link property.
+   * \return on-link flag
+   */
+  bool GetOnLink () const;
+
 #if 0
   /**
    * \brief Start the DAD timer.
@@ -188,6 +208,11 @@
   Scope_e m_scope;
 
   /**
+   * \brief The address belongs to an on-link network.
+   */
+  bool m_onLink;
+
+  /**
    * \brief Equal to operator.
    *
    * \param a the first operand
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv6-l3-protocol.cc ns-3.34/src/internet/model/ipv6-l3-protocol.cc
--- ns-3.33/src/internet/model/ipv6-l3-protocol.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv6-l3-protocol.cc	2021-07-14 10:31:06.000000000 -0700
@@ -310,9 +310,21 @@
 
   Address addr = GetInterface (interface)->GetDevice ()->GetAddress ();
 
-  if (flags & (1 << 6)) /* auto flag */
+  if (!defaultRouter.IsAny())
+    {
+      GetRoutingProtocol ()->NotifyAddRoute (Ipv6Address::GetAny (), Ipv6Prefix ((uint8_t)0), defaultRouter, interface, network);
+    }
+
+  bool onLink = false;
+  if (flags & Icmpv6OptionPrefixInformation::ONLINK)
+    {
+      onLink = true;
+    }
+
+  if (flags & Icmpv6OptionPrefixInformation::AUTADDRCONF) /* auto flag */
     {
       address = Ipv6Address::MakeAutoconfiguredAddress (addr, network);
+      address.SetOnLink (onLink);
 
       /* see if we have already the prefix */
       for (Ipv6AutoconfiguredPrefixListI it = m_prefixes.begin (); it != m_prefixes.end (); ++it)
@@ -328,21 +340,21 @@
 
       /* no prefix found, add autoconfigured address and the prefix */
       NS_LOG_INFO ("Autoconfigured address is :" << address.GetAddress ());
-      AddAddress (interface, address);
-
-      /* add default router
-       * if a previous default route exists, the new ones is simply added
-       */
-      if (!defaultRouter.IsAny())
-        {
-          GetRoutingProtocol ()->NotifyAddRoute (Ipv6Address::GetAny (), Ipv6Prefix ((uint8_t)0), defaultRouter, interface, network);
-        }
+      AddAddress (interface, address, onLink);
 
       Ptr<Ipv6AutoconfiguredPrefix> aPrefix = CreateObject<Ipv6AutoconfiguredPrefix> (m_node, interface, network, mask, preferredTime, validTime, defaultRouter);
       aPrefix->StartPreferredTimer ();
 
       m_prefixes.push_back (aPrefix);
     }
+
+  if (onLink) /* on-link flag */
+    {
+      /* add default router
+       * if a previous default route exists, the new ones is simply added
+       */
+      m_routingProtocol->NotifyAddRoute (network, mask, Ipv6Address::GetAny (), interface);
+    }
 }
 
 void Ipv6L3Protocol::RemoveAutoconfiguredAddress (uint32_t interface, Ipv6Address network, Ipv6Prefix mask, Ipv6Address defaultRouter)
@@ -376,16 +388,24 @@
   GetRoutingProtocol ()->NotifyRemoveRoute (Ipv6Address::GetAny (), Ipv6Prefix ((uint8_t)0), defaultRouter, interface, network);
 }
 
-bool Ipv6L3Protocol::AddAddress (uint32_t i, Ipv6InterfaceAddress address)
+bool Ipv6L3Protocol::AddAddress (uint32_t i, Ipv6InterfaceAddress address, bool addOnLinkRoute)
 {
   NS_LOG_FUNCTION (this << i << address);
   Ptr<Ipv6Interface> interface = GetInterface (i);
+  address.SetOnLink (addOnLinkRoute);
   bool ret = interface->AddAddress (address);
 
   if (m_routingProtocol != 0)
     {
       m_routingProtocol->NotifyAddAddress (i, address);
     }
+
+  if (addOnLinkRoute)
+    {
+      Ipv6Address networkAddress = address.GetAddress ().CombinePrefix (address.GetPrefix ());
+      Ipv6Prefix networkMask = address.GetPrefix ();
+      GetRoutingProtocol ()->NotifyAddRoute (networkAddress, networkMask, Ipv6Address::GetZero (), i);
+    }
   return ret;
 }
 
@@ -1581,5 +1601,54 @@
   return true;
 }
 
+bool Ipv6L3Protocol::ReachabilityHint (uint32_t ipInterfaceIndex, Ipv6Address address)
+{
+  if (ipInterfaceIndex >= m_interfaces.size ())
+    {
+      return false;
+    }
+
+  Ptr<NdiscCache> ndiscCache = m_interfaces[ipInterfaceIndex]->GetNdiscCache ();
+  if (!ndiscCache)
+    {
+      return false;
+    }
+
+  NdiscCache::Entry* entry = ndiscCache->Lookup (address);
+  if (!entry || entry->IsIncomplete ())
+    {
+      return false;
+    }
+
+
+  if (entry->IsReachable ())
+    {
+      entry->UpdateReachableTimer ();
+    }
+  else if (entry->IsPermanent ())
+    {
+      return true;
+    }
+  else if (entry->IsProbe ())
+    {
+      // we just confirm the entry's MAC address to get the waiting packets (if any)
+      std::list<NdiscCache::Ipv6PayloadHeaderPair> waiting = entry->MarkReachable (entry->GetMacAddress ());
+      for (std::list<NdiscCache::Ipv6PayloadHeaderPair>::const_iterator it = waiting.begin (); it != waiting.end (); it++)
+        {
+          ndiscCache->GetInterface ()->Send (it->first, it->second, it->second.GetSourceAddress ());
+        }
+      entry->ClearWaitingPacket ();
+      entry->StartReachableTimer ();
+    }
+  else // STALE OR DELAY
+    {
+      entry->MarkReachable ();
+      entry->StartReachableTimer ();
+    }
+
+
+  return true;
+}
+
 } /* namespace ns3 */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv6-l3-protocol.h ns-3.34/src/internet/model/ipv6-l3-protocol.h
--- ns-3.33/src/internet/model/ipv6-l3-protocol.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv6-l3-protocol.h	2021-07-14 10:31:06.000000000 -0700
@@ -210,10 +210,11 @@
   /**
    * \brief Add an address on interface.
    * \param i interface index
-   * \param address to add
+   * \param address address to add
+   * \param addOnLinkRoute add on-link route to the network (default true)
    * \returns true if the operation succeeded
    */
-  bool AddAddress (uint32_t i, Ipv6InterfaceAddress address);
+  bool AddAddress (uint32_t i, Ipv6InterfaceAddress address, bool addOnLinkRoute = true);
 
   /**
    * \brief Get an address.
@@ -448,6 +449,25 @@
    */
   bool IsRegisteredMulticastAddress (Ipv6Address address, uint32_t interface) const;
 
+  /**
+   * Provides reachability hint for Neighbor Cache Entries from L4-L7 protocols.
+   * 
+   * This function shall be called by L4-L7 protocols when an address is confirmed
+   * to be reachable (i.e., at least a packet send and a reply received).
+   * The net effect is to extend the NCE reachability time if the NCE is in
+   * REACHABLE state, and to mark the NCE as REACHABLE if it is in STALE, PROBE, or
+   * DELAY states. NCEs in INCOMPLETE state are not changed.
+   * 
+   * Note that the IP interface index might not be the same as the NetDevice index.
+   * The correct way to check the IP interface index is by using 
+   * Ipv6::GetInterfaceForDevice ().
+   * 
+   * \param ipInterfaceIndex IP interface index
+   * \param address reachable address
+   * \return true if the NCE has been successfully updated.
+   */
+  bool ReachabilityHint (uint32_t ipInterfaceIndex, Ipv6Address address);
+
 protected:
   /**
    * \brief Dispose object.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv6-list-routing.cc ns-3.34/src/internet/model/ipv6-list-routing.cc
--- ns-3.33/src/internet/model/ipv6-list-routing.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv6-list-routing.cc	2021-07-14 10:31:06.000000000 -0700
@@ -216,7 +216,7 @@
 
   *stream->GetStream () << "Node: " << m_ipv6->GetObject<Node> ()->GetId ()
                         << ", Time: " << Now().As (unit)
-                        << ", Local time: " << GetObject<Node> ()->GetLocalTime ().As (unit)
+                        << ", Local time: " << m_ipv6->GetObject<Node> ()->GetLocalTime ().As (unit)
                         << ", Ipv6ListRouting table" << std::endl;
   for (Ipv6RoutingProtocolList::const_iterator i = m_routingProtocols.begin ();
        i != m_routingProtocols.end (); i++)
